/*
Copyright 2002 Steve Jolly

This file is part of BridgeBot

BridgeBot is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; specifically version 2 of the License.

BridgeBot is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with BridgeBot; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import org.jibble.pircbot.*;

public class BridgeBot extends PircBot {
	public BridgeBot otherBot;
	public String ServerName;
	public String ChannelName;

	public BridgeBot() {
	    this.setName("bridge");
	    this.setLogin("bridgebot");
	    this.otherBot=this;
	}

	public BridgeBot(String Name) {
            this.setName(Name);
            this.setLogin("bridgebot");
	    this.otherBot=this;
	}

	public void onMessage(String channel, String sender, String login, String hostname, String message) {
	    System.out.println(sender+": "+message);
	    if (!sender.equals(this.getName())) { //prevent bot from locking up if this.otherBot hasn't been reinitialised
	    	if (message.startsWith(this.getName())) { //if the bot is addressed
		    this.otherBot.sendMessage(this.getName(),message); //pass the message on to the real version of this bot, via the otherBot
			}
	    }
	}

	public void onPrivateMessage(String sender, String login, String hostname, String message)  {
	    if (!sender.equals(this.getName())) { //prevent bot from locking up if this.otherBot hasn't been reinitialised
		if (sender.equals(this.otherBot.getName())) { //if this is a message from the real version of the otherBot
		    this.otherBot.sendMessage(this.otherBot.ChannelName, message);
		}
	    }
	}
	
	protected void onDisconnect () {
		int tries=0;
		while (tries<1000000 && !isConnected()) {
			try {
				connect(ServerName, 6667, "foobar");
				joinChannel(ChannelName);
			} catch (Exception e) {
				System.out.println("Connection attempt "+tries+" failed.");
				tries++;
				if (tries==1000000) System.exit(0);
			}
		} //while
	}
}
